//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSilver
#property indicator_color4  clrSilver
#property indicator_color5  clrDeepSkyBlue
#property indicator_color6  clrSandyBrown
#property indicator_color7  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame   = PERIOD_CURRENT; // timeframe to use
extern int                period      = 14;             // Calculating period
extern ENUM_APPLIED_PRICE price       = PRICE_CLOSE;    // Price
extern int                aperiod     = 14;             // Average period
extern ENUM_MA_METHOD     amethod     = MODE_EMA;       // Average method
extern bool               Interpolate = true;           // use interpolation true/false

double bufferu[];
double bufferuh[];
double bufferd[];
double bufferdh[];
double buffera[];
double bufferada[];
double bufferadb[];
double trend[];
double prices[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,bufferuh ,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferdh ,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferu  ,INDICATOR_DATA);
   SetIndexBuffer(3,bufferd  ,INDICATOR_DATA);
   SetIndexBuffer(4,buffera  ,INDICATOR_DATA);
   SetIndexBuffer(5,bufferada,INDICATOR_DATA);
   SetIndexBuffer(6,bufferadb,INDICATOR_DATA);
   SetIndexBuffer(7,trend    ,INDICATOR_CALCULATIONS);
   SetIndexBuffer(8,prices   ,INDICATOR_CALCULATIONS);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" momentum trend ("+(string)period+","+(string)aperiod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);
           if (returnBars) { bufferuh[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     if (trend[limit]==-1) CleanPoint(limit,bufferada,bufferadb);
     for(int i=limit; i>=0; i--)
     {
        prices[i] = iMA(NULL,0,aperiod,0,amethod,price,i);
        double avgUp=0,avgDn=0,up=0,dn=0;
           for(int k=0; k<period && (i+k+1)<Bars; k++)
           {
              double diff = prices[i+k]- prices[i+k+1];
              if(diff>0) { avgUp += diff; up++; }
              if(diff<0) { avgDn -= diff; dn++; }
           }
           if (up!=0) avgUp /= up;
           if (dn!=0) avgDn /= dn;
         
           //
           //
           //
           //
           //
         
           bufferuh[i]  = EMPTY_VALUE;
           bufferdh[i]  = EMPTY_VALUE;
           bufferada[i] = EMPTY_VALUE;
           bufferadb[i] = EMPTY_VALUE;
           bufferd[i]   = -avgDn;
           bufferu[i]   =  avgUp;
           if (i<Bars-1)
           {
              trend[i] = trend[i+1];
                 if (avgUp>MathAbs(avgDn)) trend[i] =  1;
                 if (avgUp<MathAbs(avgDn)) trend[i] = -1;
                 if (trend[i]== 1) { bufferuh[i] =  avgUp; buffera[i] =  avgUp;                                           }
                 if (trend[i]==-1) { bufferdh[i] = -avgDn; buffera[i] = -avgDn; PlotPoint(i,bufferada,bufferadb,buffera); }
           }         
   
   }      
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trend[limit]==-1) CleanPoint(limit,bufferada,bufferadb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         bufferuh[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,0,y);
         bufferdh[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,1,y);
         bufferu[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,2,y);
         bufferd[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,3,y);
         buffera[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,4,y);
         trend[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,price,aperiod,amethod,7,y);
         bufferada[i] = EMPTY_VALUE;
         bufferadb[i] = EMPTY_VALUE;
         
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  int n,x; datetime time = iTime(NULL,TimeFrame,y);
                  for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                  for(x = 1; x<n && (i+n)<Bars && (i+x)<Bars; x++) 
                  {
                     bufferu[i+x] = bufferu[i] + (bufferu[i+n] - bufferu[i]) * x/n;
                     bufferd[i+x] = bufferd[i] + (bufferd[i+n] - bufferd[i]) * x/n;
                     buffera[i+x] = buffera[i] + (buffera[i+n] - buffera[i]) * x/n;
                     if (bufferuh[i]!= EMPTY_VALUE) bufferuh[i+x] = buffera[i+x];
                     if (bufferdh[i]!= EMPTY_VALUE) bufferdh[i+x] = buffera[i+x];
                  }
              
      }
for (int i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,bufferada,bufferadb,buffera);       
return(0);
}        
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}